# CREATING HYETOGRAPHS FROM THE IDF CURVES

#Guro Heimstad Kliven
#Trondheim, 08.03.17

#REMEMBER TO CHANGE INPUT AND OUTPUT (buttom of file) NAME FOR DIFFERENT 
#SCENARIOS AND RETURN PERIODS
#CHANGE ALSO THE ROWS FOR DIFFERENT RETURN PERIODS (LINE 26 -->)

setwd("C:/Users/Bruker/OneDrive - NTNU/Masteroppgave/Temporal downscaling")

#Get the IDF data
idf <- read.table("IDF_WGRCP85highstlandet.txt", header = TRUE)   #This file is for observed. 
#Remember to change the file

#Get the wet days beforehand and after
wd <- read.table("Two days average PRCP.txt", header = FALSE)

#1 hour duration hyetograph
#--------------------------

#20 years return period (column = 4: change column for other return periods and change 
#name on output text file)

##Calculate the hydrograph
v15 <- idf[1,4]*15
v30 <- idf[2,4]*30
v60 <- idf[3,4]*60

i15 <- v15/15
i30 <- (v30-v15)/15
i60 <- (v60-v30)/30

##Make a time series from the hydrograph (1 minute steps)
p60 <- i60/60
p30 <- i30/60
p15 <- i15/60

zero <- c(rep(0, length = 2880 ))

time <- c(0:5836)
prec <- c(0, wd$V1, rep(p60, length = 15),
          rep(p30, length = 8), rep(p15, length = 15), rep(p30, length = 7),
          rep(p60, length = 15), wd$V1)
evap <- c(rep(0, length = 5837))
hyet <- data.frame(time, prec, evap)
colnames(hyet) <- c("time (min)", "prec (mm)", "evap (mm)")
hyet

precvolume <- c( rep(p60, length = 15),
          rep(p30, length = 8), rep(p15, length = 15), rep(p30, length = 7),
          rep(p60, length = 15))
sum(precvolume)

plot(precvolume)

#precd <- c(0,rep(p1440, length = 360), rep(p720, length = 180), 
#          rep(p360, length = 90), rep(p180, length = 60), rep(p60, length = 15),
#          rep(p30, length = 8), rep(p15, length = 15), rep(p30, length = 7),
#          rep(p60, length = 15), rep(p180, length = 60), rep(p360, length = 90),
#          rep(p720, length = 180), rep(p1440, length = 360))

write.table(hyet, file = "hyet1hrQ20observed_15min-1day_KF20.txt", col.names = TRUE, row.names = FALSE, sep = "\t")
