#IDF CURVES FOR PROJECTED CLIMATE

##Guro Heimstad Kliven
## Script made 10.03.17

#REMEMBER TO CHANGE THE INPUT AND OUTPUT (buttom of script) FILE NAME

require("evd")

setwd("C:/Users/Bruker/OneDrive - NTNU/Masteroppgave/Temporal downscaling")

#Import the projected future AM
################################
dAM <- read.table("Bias correctedWG_obs.txt", header = TRUE)

#Import the scaling factor - DON'T CHANGE
###########################
fscaling <- read.table("Scaling factor.txt")
s <- round(fscaling[1,1], digits = 3) #Round down to three decimals

#Calculate the GEV parameters for projected climate
###################################################

#Daily
dGEVfit <- fgev(dAM$AM)                           #Fit the data to the GEV-distribution
dGEVfit
par(mfrow = c(2,2))
plot(dGEVfit)

dpar <- as.numeric(dGEVfit$estimate)              #Get the estimated parameters

dxi <- dpar[3]                                    # xi for daily precipitation
dmu <- dpar[1]                                    # mu for daily precipitation
dbeta <- dpar[2]                                  # beta for daily precipitation

#Find lambda
durationsMinute <- c(15, 30, 60*1, 60*3, 60*6, 12*60)
durationsHour <- durationsMinute/60
lambda <- durationsHour/24 
#min2lambda <- lambda[1]
#min5lambda <- lambda[1]
min15lambda <- lambda[1]
min30lambda <- lambda[2]
hr1lambda <- lambda[3]
hr3lambda <- lambda[4]
hr6lambda <- lambda[5]
hr12lambda <- lambda[6]

#2 min
#min2xi <- dxi
#min2mu <- min2lambda^(s)*dmu
#min2beta <- min2lambda^(s)*dbeta

#5min
#min5xi <- dxi
#min5mu <- min5lambda^(s)*dmu
#min5beta <- min5lambda^(s)*dbeta

#15min
min15xi <- dxi
min15mu <- min15lambda^(s)*dmu
min15beta <- min15lambda^(s)*dbeta

#30 min
min30xi <- dxi
min30mu <- min30lambda^(s)*dmu
min30beta <- min30lambda^(s)*dbeta

#1 hr
hr1xi <- dxi
hr1mu <- hr1lambda^(s)*dmu
hr1beta <- hr1lambda^(s)*dbeta

#3 hr
hr3xi <- dxi
hr3mu <- hr3lambda^(s)*dmu
hr3beta <- hr3lambda^(s)*dbeta

#6 hr
hr6xi <- dxi
hr6mu <- hr6lambda^(s)*dmu
hr6beta <- hr6lambda^(s)*dbeta

#12 hr
hr12xi <- dxi
hr12mu <- hr12lambda^(s)*dmu
hr12beta <- hr12lambda^(s)*dbeta

#24 hr
#1 hr#
#hr1xi <- dxi
#hr1mu <- dmu
#hr1beta <- hr1lambda^(s)*dbeta


#Estimate the quantiles for IDF cunstruction
############################################
#Because of the scaling factor only durations up to 6 hr are calculated

Treturn <- c(2, 5, 10, 20, 30, 50, 100)       #return period
p <- 1/Treturn                                #probability

##2 min
#min2Xt <- min2mu - (min2beta/min2xi)*(1-(-log(1-p))^(-min2xi))
#par(mfcol = c(1, 1))
#plot(Treturn, min2Xt, ylab = "Return level (mm)")

##5 min
#min5Xt <- min5mu - (min5beta/min5xi)*(1-(-log(1-p))^(-min5xi))
#par(mfcol = c(1, 1))
#plot(Treturn, min5Xt, ylab = "Return level (mm)")

##15 min
min15Xt <- min15mu - (min15beta/min15xi)*(1-(-log(1-p))^(-min15xi))
par(mfcol = c(1, 1))
plot(Treturn, min15Xt, ylab = "Return level (mm)")

##30 min
min30Xt <- min30mu - (min30beta/min30xi)*(1-(-log(1-p))^(-min30xi))
par(mfcol = c(1, 1))
plot(Treturn, min30Xt, ylab = "Return level (mm)")

##1 hr
hr1Xt <- hr1mu - (hr1beta/hr1xi)*(1-(-log(1-p))^(-hr1xi))
par(mfcol = c(1, 1))
plot(Treturn, hr1Xt, ylab = "Return level (mm)")

##3 hr
hr3Xt <- hr3mu - (hr3beta/hr3xi)*(1-(-log(1-p))^(-hr3xi))
par(mfcol = c(1, 1))
plot(Treturn, hr3Xt, ylab = "Return level (mm)")

##6 hr
hr6Xt <- hr6mu - (hr6beta/hr6xi)*(1-(-log(1-p))^(-hr6xi))
par(mfcol = c(1, 1))
plot(Treturn, hr6Xt, ylab = "Return level (mm)")

##12 hr
hr12Xt <- hr12mu - (hr12beta/hr12xi)*(1-(-log(1-p))^(-hr12xi))
par(mfcol = c(1, 1))
plot(Treturn, hr12Xt, ylab = "Return level (mm)")

##24 hr
hr24Xt <- dmu - (dbeta/dxi)*(1-(-log(1-p))^(-dxi))
par(mfcol = c(1, 1))
plot(Treturn, hr24Xt, ylab = "Return level (mm)")

##Make a new matrix with all durations and return values 
m <- matrix(c(min15Xt, min30Xt, hr1Xt, hr3Xt, hr6Xt, hr12Xt, hr24Xt), 
            nrow = length(Treturn))
colnames(m, do.NULL = FALSE)
colnames(m) <- c("15min","30 min", "60min",
                 "180 min", "360 min", "720 min", "1440 min")
rownames(m) <- c("2years", "5years", "10years", "20years", "30years", 
                 "50years", "100years")
m

tm <- as.data.frame(t(m)) # Transform the matrix
xIDF <- c(15, 30, 60, 180, 360, 720, 1440)
tmIDF <- (tm/xIDF)*60 #From depth (mm) to intensity (mm/hr)
x <- factor(c(15, 30, 60, 180, 360, 720, 1440)) #Values on x-axis
dat <- data.frame(x, tm)
datIDF <- data.frame(x, tmIDF)

##Plot the DDF curve
with(dat, plot(x, dat$X100years, type = "l", xaxt = 'n')) #To get uneven distance on x axis
with(dat, plot(as.numeric(x), tm$`100years`, type = "l", xaxt = "n", 
               xlab = 'Duration (min)', ylab = 'Depth (mm)')) # points instead of steps
lines(x, dat$X50years, col = "red", lty = 2)
lines(x, dat$X30years, col = "blue", lty = 3)
lines(x, dat$X20years, lty = 6)
lines(x, dat$X10years, col = "51",  lty = 5)
lines(x, dat$X5years, col = "red", lty = 4)
lines(x, dat$X2years, col = "blue")
axis(side = 1, at = x,labels = as.character(dat$x)) #Get exactly the value I want on x-axis
legend("topleft", title = 'Return period (years)', lty = c(1, 2, 3, 6, 5, 4, 1), 
       col = c('black', 'red', 'blue','black', "51", 'red', 'blue'),
       c('100', '50', '30', '20', '10', '5', '2'))

#Plot the IDF curve
with(datIDF, plot(x, datIDF$X100years, type = "l", xaxt = 'n')) #To get uneven distance on x axis
with(datIDF, plot(as.numeric(x), tmIDF$`100years`, type = "l", xaxt = "n", ylim = c(0,75),
                  xlab = 'Duration (min)', ylab = 'Intensity (mm/hr)')) # points instead of steps
lines(x, datIDF$X50years, col = "red", lty = 2)
lines(x, datIDF$X30years, col = "blue", lty = 3)
lines(x, datIDF$X20years, lty = 6)
lines(x, datIDF$X10years, col = "51",  lty = 5)
lines(x, datIDF$X5years, col = "red", lty = 4)
lines(x, datIDF$X2years, col = "blue")
axis(side = 1, at = x,labels = as.character(datIDF$x)) #Get exactly the value I want on x-axis
legend("topright", title = 'Return period (years)', lty = c(1, 2, 3, 6, 5, 4, 1), 
       col = c('black', 'red', 'blue','black', "51", 'red', 'blue'),
       c('100', '50', '30', '20', '10', '5', '2'))

write.table(tmIDF, "IDF_WGhistorical 15 min - 1 day.txt", col.names = TRUE, row.names = TRUE)
